---
title: PaymentRequestEvent.respondWith()
slug: Web/API/PaymentRequestEvent/respondWith
tags:
  - API
  - Method
  - Payment Request API
  - PaymentRequestEvent
  - Reference
  - payment
  - respondWith()
---
<p>{{APIRef("Payment Request API")}}{{SeeCompatTable}}</p>

<p>The <strong><code>respondWith</code></strong> property of the {{domxref("PaymentRequestEvent")}} interface prevents the default event handling and allows you to provide a {{jsxref("Promise")}} for a {{domxref("PaymentResponse")}} object yourself.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">paymentRequestEvent.respondWith(
  // Promise that resolves with a PaymentResponse.
)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>promise</dt>
 <dd>A {{jsxref('Promise')}} that resolves with a {{domxref("PaymentResponse")}} object.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("PaymentResponse")}} object.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment Handler','','respondWith')}}</td>
   <td>{{Spec2('Payment Handler')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PaymentRequestEvent.respondWith")}}</p>
